
#if	!defined(PTR)
#error missing macro-constant "PTR".
#elif	PTR<0 || PTR>2
#error bad value of macro-constant "PTR".
#endif

#if	!defined(TSH)
#error missing macro-constant "TSH".
#elif	TSH<0 || TSH>5
#error bad value of macro-constant "TSH".
#endif

#include <stdio.h>
#include <stdlib.h>

#if	PTR==0
#include <math.h>	/* for log() */
#endif

#include "rif_f.h"
#include "csi_f.h"
#include "sif_f.h"

extern void	Error(char *msg);

static void	XPTR(double i0,FOM *i)
{
#if	PTR==0
	*i=(i0<=0.0 || *i<=0.0)?0.0:log(i0/(*i));
#elif	PTR==1
	*i=(i0<=0.0)?0.0:*i/i0;
#elif	PTR==2
	*i-=i0;
#endif
}

#define LEN	2048

int	main(int argc,char **argv)
{
	char	**path,str[LEN];
	int	Nx,Ny,Nz,len,z,x,y;
	FOM	**fom;

#if	PTR==0
#define PREFIX	"ri2xp"
#define RAW	"RI/"
#define RG	"XP/"
#elif	PTR==1
#define PREFIX	"ri2xt"
#define RAW	"RI/"
#define RG	"XT/"
#elif	PTR==2
#define PREFIX	"rr2xr"
#define RAW	"RR/"
#define RG	"XR/"
#endif

#if	TSH==0
	int	Nt;

#define ARGC	5
#define SUFFIX	"t"
#define MARGIN	"top"
#elif	TSH==1
	int	Nl,Nr,LR;

#define ARGC	6
#define SUFFIX	"s"
#define MARGIN	"left right"
#else
	int	Nt,Nl,Nr,LR;
	double	*T;

#define ARGC	7
#if	TSH==2
#define SUFFIX	"h_0"
#elif	TSH==3
#define SUFFIX	"h_1"
#elif	TSH==4
#define SUFFIX	"h_2"
#elif	TSH==5
#define SUFFIX	"h_3"
#endif
#define MARGIN	"top left right"
#endif

	if (argc!=ARGC)
	    Error("usage : " PREFIX "_" SUFFIX " " RAW " NF " MARGIN " " RG);

	path=CheckSliceImages_Float(argv[1],argv[2],&Nx,&Ny,&Nz,NULL);

#if	TSH==0
	if ((Nt=atoi(argv[3]))<=0 || Nt>=Ny) Error("bad top margin.");
#elif	TSH==1
	if ((Nl=atoi(argv[3]))<0 ||
	    (Nr=atoi(argv[4]))<0 || (LR=Nl+Nr)<=0 || LR>=Nx)
	    Error("bad left and/or right margin.");
#elif	TSH>=2 && TSH<=5
	if ((Nt=atoi(argv[3]))<=0 || Nt>=Ny ||
	    (Nl=atoi(argv[4]))<0 ||
	    (Nr=atoi(argv[5]))<0 || (LR=Nl+Nr)<(int)(TSH/2) || LR>=Nx)
	    Error("bad top, left and/or right margin.");

	if ((T=(double *)malloc(sizeof(double)*Nx))==NULL)
	    Error("memory allocation error.");
#endif

	for (len=0; argv[1][len]!='\0'; len++) ;

	for (z=0; z<Nz; z++) {
	    (void)ReadImageFile_Float(path[z],&x,&y,&fom,NULL);
	    if (x!=Nx || y!=Ny) Error("image size not match.");

#if	TSH==0
{
	double	t,i0;

	for (x=0; x<Nx; x++) {
	    t=0.0; for (y=0; y<Nt; y++) t+=fom[y][x];

	    i0=t/(double)Nt; for (y=0; y<Ny; y++) XPTR(i0,fom[y]+x);
	}
}
#elif	TSH==1
	for (y=0; y<Ny; y++)
{
	FOM	*i=fom[y];
	double	a,b,l=0.0,r=0.0;

	for (x=0    ; x<Nl; x++) l+=i[x];
	for (x=Nx-Nr; x<Nx; x++) r+=i[x];

	if (Nl==0 || Nr==0) {
	    a=0.0; b=(l+r)/(double)LR;
	}
	else {
	    l/=(double)Nl; r/=(double)Nr;
	    a=(r-l)/((double)Nx-(double)LR/2.0); b=l-a*(double)(Nl-1)/2.0;
	}
	for (x=0; x<Nx; x++) XPTR(a*(double)x+b,i++);
}
#else
	for (x=0; x<Nx; x++) T[x]=0.0;

	for (y=0; y<Nt; y++)
{
	FOM	*i=fom[y];

	for (x=0; x<Nx; x++) T[x]+=i[x];
}
	for (y=0; y<Ny; y++)
{
	FOM	*i=fom[y];

#if	TSH==2
	double	c=0.0;

	for (x=0    ; x<Nl; x++) c+=(i[x]/T[x]);
	for (x=Nx-Nr; x<Nx; x++) c+=(i[x]/T[x]);

	c/=(double)LR; for (x=0; x<Nx; x++) XPTR(c*T[x],i+x);
#elif	TSH==3
	double	t,c,s1=0.0,s2=0.0;

	for (x=0    ; x<Nl; x++) {
	    t=T[x]; s1+=(t*t); s2+=(i[x]*t);
	}
	for (x=Nx-Nr; x<Nx; x++) {
	    t=T[x]; s1+=(t*t); s2+=(i[x]*t);
	}
	c=s2/s1; for (x=0; x<Nx; x++) XPTR(c*T[x],i+x);
#elif	TSH==4
	double	X,it,d,a,b,s1=0.0,s2=0.0,s3=0.0,s4=0.0;

	for (x=0    ; x<Nl; x++) {
	    X=(double)x; it=i[x]/T[x]; s1+=(X*X); s2+=X; s3+=(X*it); s4+=it;
	}
	for (x=Nx-Nr; x<Nx; x++) {
	    X=(double)x; it=i[x]/T[x]; s1+=(X*X); s2+=X; s3+=(X*it); s4+=it;
	}
	d=s1*(double)LR-s2*s2; a=((double)LR*s3-s2*s4)/d; b=(s1*s4-s2*s3)/d;
	for (x=0; x<Nx; x++) XPTR((a*(double)x+b)*T[x],i+x);
#elif	TSH==5
	double	X,X2,t,t2,it,d,a,b,s1=0.0,s2=0.0,s3=0.0,s4=0.0,s5=0.0;

	for (x=0    ; x<Nl; x++) {
	    X=(double)x; X2=X*X; t=T[x]; t2=t*t; it=i[x]*t;
	    s1+=(X2*t2); s2+=(X*t2); s3+=t2; s4+=(X*it); s5+=it;
	}
	for (x=Nx-Nr; x<Nx; x++) {
	    X=(double)x; X2=X*X; t=T[x]; t2=t*t; it=i[x]*t;
	    s1+=(X2*t2); s2+=(X*t2); s3+=t2; s4+=(X*it); s5+=it;
	}
	d=s1*s3-s2*s2; a=(s3*s4-s2*s5)/d; b=(s1*s5-s2*s4)/d;
	for (x=0; x<Nx; x++) XPTR((a*(double)x+b)*T[x],i+x);
#endif
}
#endif

	    (void)sprintf(str,"%s/%s",argv[argc-1],path[z]+len+1);
	    StoreImageFile_Float(str,Nx,Ny,fom,SIF_F_desc);
	    (void)printf("%d\t%s\n",z,SIF_F_desc);
	
	    for (y=0; y<Ny; y++) free(fom[y]); free(fom); free(path[z]);
	}

#if	TSH>=2 && TSH<=5
	free(T);
#endif

	free(path); 

	return 0;
}
