#!/bin/csh
if ($#argv != 4) then
  echo echo usage : mf.csh RP.tif Wm Ws MF.tif 1\>\&2 | /bin/sh ; exit 1
endif
#
t_f2txt $argv[1] %lf - | \
awk -v Wm=$argv[2] -v Ws=$argv[3] \
    'BEGIN { if (Wm<0 || Ws<2) exit 1 } \
     NR==1 { print } \
     NR>=2 { for (f=1; f<=NF; f++) if (f==1 || $f>peak) { f0=f; peak=$f } \
             f1=(f2=f0-Wm)-Ws; f4=(f3=f0+Wm)+Ws; c=x=y=xx=xy=0; \
             for (f=1; f<=NF; f++) \
               if ((f<f2 || f>f3) && f>=f1 && f<=f4) { \
                 ++c; x+=f; y+=$f; xx+=(f*f); xy+=(f*$f) } \
             if (c<2) \
               a=b=0; \
             else { \
               d=xx*c-x*x; a=(c*xy-x*y)/d; b=(xx*y-x*xy)/d } \
             for (f=1; f<=NF; f++) \
               if (f<f2 || f>f3) print $f; else printf "%f\n",a*f+b }' | \
txt2t_f - $argv[4]
