
#include <stdio.h>
#include <stdlib.h>
#include "rif_f.h"
#include "csi_f.h"

extern void	Error(char *msg);

int	main(int argc,char **argv)
{
	char	**path;
	int	Ns,Nz,Nv,V,Z,v,s,z;
	FILE	*file;
	FOM	**F,*f;
	double	d;

	if (argc!=5) Error("usage : raw2sg raw/ NF layer SG");

	path=CheckSliceImages_Float(argv[1],argv[2],&Ns,&Nz,&Nv,NULL);

	if (Nv<2) Error("too few views.");

	if ((Z=atoi(argv[3]))<0 || Z>=Nz) Error("bad sinogram layer.");

	if (argv[4][0]=='-')
	    file=stdout;
	else
	    if ((file=fopen(argv[4],"wb"))==NULL) Error("file not open.");

	(void)fprintf(file,"%d\t%d\n",Ns,V=Nv-1);

	for (v=0; v<V; v++) {
	    (void)ReadImageFile_Float(path[v],&s,&z,&F,NULL);
	    if (s!=Ns || z!=Nz) Error("image size not match.");

	    for (f=F[Z], s=0; s<Ns; s++, f++) {
		d=(*f); (void)fwrite(&d,sizeof(double),1,file);
	    }
	    for (z=0; z<Nz; z++) free(F[z]); free(F); free(path[v]);
	}
	if (file!=stdout) (void)fclose(file);

	free(path[V]); free(path); 

	return 0;
}
