
#include <stdio.h>
#include <stdlib.h>
#include "cbp.h"
#include "sif_f.h"

extern void	Error(char *msg);

/*
	assuming Float == FOM == double
*/

#define LEN	2048
#define EPS	1e-9
#define PI	3.14159265358979323846

int	main(argc,argv)
int	argc;
char	**argv;
{
	FILE	*F;
	char	S[LEN];
	int	N,M,m;
	double	dr,r0,**P;

	if (argc!=6) Error("usage : sg2tg_f SG dr r0/dr ra TG");

	if (argv[1][0]=='-')
	    F=stdin;
	else
	    if ((F=fopen(argv[1],"rb"))==NULL) Error("sinogram not found.");

	if (fgets(S,LEN,F)==NULL ||
	    sscanf(S,"%d %d",&N,&M)!=2 ||
	    N<=0 || M<=0) Error("bad sinogram size.");

	if ((dr=atof(argv[2]))>(-EPS) && dr<EPS)
	    Error("bad detector interval.");

	if ((r0=atof(argv[3]))>=0.0 || r0<=(double)(1-N))
	    Error("bad detector offset (unit in detector interval).");

	if ((P=InitCBP(N,M))==NULL) Error("memory allocation error.");

	for (m=0; m<M; m++)
	    if (fread(P[m],sizeof(double),N,F)!=N) Error("sinogram read error");

	if (F!=stdin) (void)fclose(F);

	StoreImageFile_Float(argv[5],N,N,
			     CBP(dr,r0,atof(argv[4])*PI/180.0),
			     SIF_F_desc);
	(void)puts(SIF_F_desc);

	TermCBP();

	return 0;
}
