
#include <stdio.h>
#include <stdlib.h>
#include "csi_f.h"
#include "rif_f.h"

extern void	Error(char *);

static char	*format;
static int	first=1;
static double	Min,Max;

#define LEN	2048

static void	Dump_TIFF_Float(int Nx,int Ny,char *path,FILE *file)
{
	int	bps,X,Y,n,y,x;
	FOM	**fom;
	char	*id,str[8][LEN],*u_c,
		*u="using integer PV as is floating-point PV",
		*c="converting PV by TIFF image description tag";
	double	min,max,b,s,pv;

	if ((bps=ReadImageFile_Float(path,&X,&Y,&fom,&id))!=0) {
	    if (id!=NULL) {
		if ((n=sscanf(id,"%s %s %s %s %s %s %s %s",
				 str[0],str[1],str[2],str[3],
				 str[4],str[5],str[6],str[7]))==2 || n==6)
		    if (sscanf(str[n-2],"%lf",&min)!=1 ||
			sscanf(str[n-1],"%lf",&max)!=1 || min>=max)
			u_c=u;
		    else {
			u_c=c; b=min; s=(max-min)/(double)((1ULL<<bps)-1);
		    }
		else
		    u_c=((n!=3 && n!=4 && n!=8) ||
			 sscanf(str[n-2],"%lf",&b)!=1 ||
			 sscanf(str[n-1],"%lf",&s)!=1 || s<=0.0)?u:c;

		free(id);
	    }
	    else
		u_c=u;
#ifdef	U_C
	    (void)fprintf(stderr,"%s : %s (warning).\n",path,u_c);
#endif
	}
	else {
	    u_c=NULL; if (id!=NULL) free(id);
	}
	if (u_c!=c) {
	    b=0.0; s=1.0;
	}
	for (y=0; y<Ny; y++) {
	    for (x=0; x<Nx; x++) {
		(void)fprintf(file,format,pv=(x<X && y<Y)?b+s*fom[y][x]:0.0);
		(void)fputc((x<Nx-1)?'\t':'\n',file);

		if (first) {
		    first=0; Min=Max=pv;
		}
		else
		    if (Min>pv) Min=pv; else if (Max<pv) Max=pv;
	    }
	    if (y<Y) free(fom[y]);
	}
	free(fom);
}

int	main(int argc,char **argv)
{
	int	Nx,Ny,z,Z=1;
	char	**path;
	FILE	*file;

	if (argc!=4 && argc!=5)
	    Error("usage : t_f2txt image.tif PV_format image.txt\n"
		  "        t_f2txt image/ nameFile PV_format image.txt");

	if (argc==4)
	    (void)ReadImageFile_Float(argv[1],&Nx,&Ny,NULL,NULL);
	else
	    path=CheckSliceImages_Float(argv[1],argv[2],&Nx,&Ny,&Z,NULL);

	format=argv[argc-2];

	if (argv[argc-1][0]=='-')
	    file=stdout;
	else
	    if ((file=fopen(argv[argc-1],"w"))==NULL) Error("file not open.");

	(void)fprintf(file,"%d\t%d",Nx,Ny);
	if (Z>1) (void)fprintf(file,"\t%d\n",Z); else (void)fputc('\n',file);

	if (argc==4)
	    Dump_TIFF_Float(Nx,Ny,argv[1],file);
	else {
	    for (z=0; z<Z; z++) {
		if (z>0) (void)fputc('\n',file);

		Dump_TIFF_Float(Nx,Ny,path[z],file); free(path[z]);
	    }
	    free(path);
	}
	(void)fprintf((file!=stdout)?stdout:stderr,"%lf\t%lf\n",Min,Max);

	if (file!=stdout) (void)fclose(file);

	return 0;
}
